#version 330
layout (location = 0) in vec3 position;                                             
layout (location = 1) in vec2 uv;                                             
layout (location = 2) in vec3 normal;   
layout (location = 3) in vec3 Tangent;

out vec3 v_position;
out vec3 v_worldNormal;
out vec3 v_view;
out vec2 fragmentUV;
out vec4 v_smPosition;
out vec3 v_tangent;

uniform mat4 m_model;
uniform mat4 m_viewProjection;
uniform mat4 m_viewProjectionL;
uniform vec3 v_cameraPos;


void main()
{
	gl_Position = m_viewProjection * m_model * vec4(position, 1);

	v_position = (m_model * vec4(position, 1)).xyz;
	
	mat4 m_normal = transpose(inverse(m_model));
	v_worldNormal = (m_normal * vec4(normal, 1)).xyz;
	v_tangent = (m_model * vec4(Tangent, 0.0)).xyz;
	v_view = v_cameraPos - v_position;
	fragmentUV = uv;
	v_smPosition = 	m_viewProjectionL * m_model * vec4(position, 1);
}