#version 330 core

in vec2 fragmentUV;

out vec4 FragColor;

uniform sampler2D i_textureUnit1;
uniform bool horizontal;

uniform float weight[5] = float[] (0.227027, 0.1945946, 0.1216216, 0.054054, 0.016216);
uniform int numWeights = 5;

void main() {
	vec2 pixelSize = 1.0/ textureSize(i_textureUnit1, 0);

	vec3 finalColor = texture(i_textureUnit1, fragmentUV).xyz * weight[0];

	if(horizontal) {
		for(int i = 1; i < numWeights; i++) {
			finalColor += texture(i_textureUnit1, fragmentUV + vec2(pixelSize.x * i, 0.0)).xyz * weight[i];
			finalColor += texture(i_textureUnit1, fragmentUV - vec2(pixelSize.x * i, 0.0)).xyz * weight[i];
		}
	} else {
		for(int i = 1; i < numWeights; i++) {
			finalColor += texture(i_textureUnit1, fragmentUV + vec2(0.0, pixelSize.y * i)).xyz * weight[i];
			finalColor += texture(i_textureUnit1, fragmentUV - vec2(0.0, pixelSize.y * i)).xyz * weight[i];
		}	
	}

	FragColor = vec4(finalColor, 1.0);
}